/*
  Copyright (C) 2001 Kimmo Pekkola

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
/*
  $Header: //rainbox/cvsroot/Rainmeter/Plugin/MeasureNet.h,v 1.5 2002/07/01 15:34:23 rainy Exp $

  $Log: MeasureNet.h,v $
  Revision 1.5  2002/07/01 15:34:23  rainy
  Now it is possible to select the NIC.

  Revision 1.4  2002/04/26 18:24:16  rainy
  Modified the Update method to support disabled measures.

  Revision 1.3  2002/04/01 15:38:25  rainy
  Some on the implementation from NetIn/Out is moved here.
  Added TrafficAction and TrafficValue.

  Revision 1.2  2001/08/12 15:45:34  Rainy
  Changed UpdateTable() to be a class method.

  Revision 1.1.1.1  2001/08/11 10:58:19  Rainy
  Added to CVS.

*/

#ifndef __MEASURENET_H__
#define __MEASURENET_H__

#include "Measure.h"
#include <Iphlpapi.h>

class CMeasureNet : public CMeasure
{
public:
	enum NET {
		NET_IN,
		NET_OUT,
		NET_TOTAL
	};

	CMeasureNet();
	virtual ~CMeasureNet();
	virtual bool Update(CMeterWindow& meterWindow);

protected:
	void ReadConfig(const char* filename, const char* section, CMeasureNet::NET net);
	void ReadStats(HKEY hKey, CMeasureNet::NET net);
	void WriteStats(HKEY hKey, CMeasureNet::NET net);
	const char* GetStats(CMeasureNet::NET net);
	UINT GetNetOctets(NET net);

	static void UpdateTable(int counter);
	static MIB_IFTABLE* c_Table;
	static int c_NumOfTables;

	ULARGE_INTEGER m_Total;
	UINT m_CurrentTraffic;
	UINT m_TrafficValue;
	UINT m_Interface;
	std::string m_TrafficAction;
};

#endif
